        !
        ! vopcode.s : utility for v68k opcodes
        !

        .sect text
        .sect rom
        .sect data
        .sect bss

	.sect text
	
!  .define _start

!_start:
!start:
begin:	
	! no interrupts
	move.w #0x2700,sr

	! setup super and user stack
	lea 0x10000,a7
	lea 0x18000,a0
	move a0,usp

	! reset the hardware
	reset
	lea 0xFFFF8800, a0
        move.b #7, (a0)
        move.b #0xC0, 2(a0)
        move.b #0xE, (a0)
        move.b #7, 2(a0)

        !
        ! reset mfp : zero almost all registers.
        !

        lea 0xFFFFfa01, a0
        move.l #0,d0
        movep.l d0, 0(a0)       ! clear gpip, aer, ddr, iera
        movep.l d0, 8(a0)       ! clear ierb, ipra, iprb, isra
        movep.l d0, 0x10(a0)    ! clear isrb, imra, imrb, vr
        move.b #0x48, 0x16(a0)  ! vr
        movep.l d0, 0x18(a0)    ! clear tacr, tbcr, tcdcr, tadr
        movep.l d0, 0x20(a0)    ! clear tbdr, tcdr, tddr, scr

        !
        ! reset acias
        !

        move.b #3,0xfffffc04        ! 3 : master reset
        move.b #0x95,0xfffffc04     ! MIDI : clock/16, 8 bit, 1 stop, no parity
        move.b #3,0xfffffc00
        move.b #0x96,0xfffffc00     ! IKBD : clock/64, 8 bit, 1 stop, no parity


	! setup super and user stack
	lea 0x10000,a7
	lea 0x18000,a0
	move a0,usp

	jsr init_exceptions
	
	! some vectors to rte.
	lea rte_vec(pc),a0
	move.l a0,0x70
	lea illg_vec(pc),a0
	move.l a0,0x10
	
	! print welcome message
	pea welcome_msg
	jsr _printf
	add.l #4,a7

	! allow interrupts. ?
	move.w #0x2000,sr
	
	! okay, enough assembler, go in C part
	jsr _vrun


	.define rte_vec
rte_vec:
	rte

illg_vec:		
	move.w (a7)+,d1
	swap d1
	move.l (a7)+,a0
	move.w (a0)+,d1
	cmp.w #0x7100,d1
	blt illg2
	cmp.w #0x7103,d1
	bgt illg2
	move.w d1,0xFFFC80
	swap d1
	move.w d1,sr
	jmp (a0)

illg2:
	! hopeless, halt the CPU.
	sub.w #1,a7
	trap #1
	! still here ?
	stop #7
	! still here ??
	bra illg2
	
welcome_msg:
	.ascii "Hello"
	.data1 10,0
	
	.align 2
	
	.define _clocks_per_sec
_clocks_per_sec:
	.data2 0x7100
	rts
	
	.define _clock
_clock:
	.data2 0x7101
	rts
	
	.define _putchar
_putchar:
	move.w 4(sp),d0
	.data2 0x7102
	rts

	.define _usermode
_usermode:
	move.l 4(sp),a0
	move.l 8(sp),a1
	and.w #0x0700,sr
	move.l a1,-(sp)
	pea userexit(pc)
	jmp (a0)

userexit:
	move.w #0,-(sp)
	bsr _exit

	.extern _exit
_exit:
	move.w 4(sp),d0
	.data2 0x7103
end:
	bra end	
	

