        !
        ! start.s : for V68k Virtual machine, Rom, no fake opcode,
        ! but special memory-mapped write register in FFFC80.
        !

        .sect text
        .sect rom
        .sect data
        .sect bss

	.sect text
	
!  .define _start

!_start:
!start:
begin:	
	! no interrupts
	move.w #0x2700,sr

	! setup super and user stack
	lea 0x10000,a7
	lea 0x18000,a0
	move a0,usp

	jsr init_exceptions
	
	! some vectors to rte.
	!lea rte_vec(pc),a0
	!move.l a0,0x70
	!lea illg_vec(pc),a0
	!move.l a0,0x10
	
	! print welcome message
	pea welcome_msg
	jsr _printf
	add.l #4,a7

	! allow interrupts. ?
	move.w #0x2000,sr
	
	! okay, enough assembler, go in C part
	jsr _vrun


!	.define rte_vec
!rte_vec:
!	rte
!
!illg_vec:		
!	move.w (a7)+,d1
!	swap d1
!	move.l (a7)+,a0
!	move.w (a0)+,d1
!	cmp.w #0x7100,d1
!	blt illg2
!	cmp.w #0x7103,d1
!	bgt illg2
!	move.w d1,0xFFFC80
!	swap d1
!	move.w d1,sr
!	jmp (a0)
!
!illg2:
!	! hopeless, halt the CPU.
!	sub.w #1,a7
!	trap #1
!	! still here ?
!	stop #7
!	! still here ??
!	bra illg2
	
welcome_msg:
	.ascii "Hello"
	.data1 10,0
	
	.align 2
	
	.define _clocks_per_sec
_clocks_per_sec:
	move.w #0x7100,0xFFFC80
	!.data2 0x7100
	rts
	
	.define _clock
_clock:
	move.w #0x7101,0xFFFC80
	!.data2 0x7101
	rts
	
	.define _putchar
_putchar:
	move.w 4(sp),d0
	move.w #0x7102,0xFFFC80
	!.data2 0x7102
	rts

	.define _usermode
_usermode:
	move.l 4(sp),a0
	move.l 8(sp),a1
	and.w #0x0700,sr
	move.l a1,-(sp)
	pea userexit(pc)
	jmp (a0)

userexit:
	move.w #0,-(sp)
	bsr _exit

	.extern _exit
_exit:
	move.w 4(sp),d0
	move.w #0x7103,0xFFFC80
	!.data2 0x7103
end:
	bra end	
	

